
int nCircles = 100;
Circle circles[] = new Circle[nCircles];

void setup() {
 size(500,500);
 
 for(int i=0; i<nCircles; i++) { 
   circles[i] = new Circle(random(0,width), random(0,height));
 }
}


void draw() {
  background(255);
  
  for(int i=0; i<nCircles; i++) {
   circles[i].update();
   circles[i].draw();
  }
}








class Circle {
  float x;
  float y; 
  float xSpeed;
  float ySpeed;
  
  Circle(float xPos,float yPos) {
    this.x = xPos;
    this.y = yPos;
    
    float speed = random(.15, .75);
    this.xSpeed = speed;
    this.ySpeed = speed;
  }
  
  void update() {
    //If it is beyond the left side
    if(this.x < 0) {
      this.x = 0;
      this.xSpeed *= -1;
    }
    
    //If it is beyond the right side
    if(this.x > width) {
      this.x = width;
      this.xSpeed *= -1;
    }
    
    //If it is above the top
    if(this.y < 0) {
      this.y = 0;
      this.ySpeed *= -1;
    }
    
    //If it is below the bottom
    if(this.y > height) {
      this.y = height;
      this.ySpeed *= -1;
    }
    
    this.x += xSpeed;
    this.y += ySpeed;
  }
  
  void draw() {
    ellipse(this.x,this.y, 20,20);
  }
}  


